Option Strict Off
Option Explicit On

Friend Class PDSA_Socket
    Inherits System.Windows.Forms.Form

    Private objSck As System.Net.Sockets.TcpClient
    Private objStm As System.Net.Sockets.NetworkStream
    Private IpSaveFileName As String

    '/***********************************************************************/
    '/*                                                                     */
    '/*     IF-70@API_Test  for Visual Basic .Net                          */
    '/*       TCP Socket                                                    */
    '/*                                                                     */
    '/*       PDSA_Socket VBA Sample : Ver 1.1.1                            */
    '/*                                                                     */
    '/*     Copyright(c) 2012 TEXIO TECHNOLOGY CORPORATION                 */
    '/***********************************************************************/
    Private Sub PDSA_Socket_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim stCurrentDir As String = System.Environment.CurrentDirectory

        IpSaveFileName = stCurrentDir + "\PDSA_Socket.txt"
        ListReceiveBx.Items.Clear()
        IpSaveFileRead()
        PDSA_CommButtonEnable(0)
    End Sub

    Private Sub PDSA_Socket_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        If PictureOnBox.Visible = True Then
            SendDataSet(False, "GTL")                       '[g
            PDSA_CommButtonEnable(2)                        'ؒf҂
            LabelReciveWork.Text = " Close"
            Me.Refresh()
            Timer1.Enabled = False
            Sleep(500)
            SocketClose()
        End If
    End Sub

    Private Sub PDSA_CommButtonEnable(ByVal mode As Integer)
        Dim sel As Boolean

        If mode = 2 Then
            sel = True
        Else
            sel = False
        End If
        PictureOnOfBox.Visible = sel
        If mode = 1 Then
            sel = True
        Else
            sel = False
        End If
        CommandDevCloseBt.Enabled = sel
        CommandOutOnBt.Enabled = sel
        CommandOutOffBt.Enabled = sel
        CommandPreset1Bt.Enabled = sel
        CommandPreset2Bt.Enabled = sel
        CommandPreset3Bt.Enabled = sel
        CommandInformationBt.Enabled = sel
        CommandMoniCurrBt.Enabled = sel
        CommandMoniVoltBt.Enabled = sel
        CommandRatedBt.Enabled = sel
        CommandRemOffBt.Enabled = sel
        TextSendBx.Enabled = sel
        CommandSendBt.Enabled = sel
        PictureOnBox.Visible = sel
        If mode = 0 Then
            sel = True
        Else
            sel = False
        End If
        CommandDevOpenBt.Enabled = sel
        TextIpAddr0Bx.Enabled = sel
        TextIpAddr1Bx.Enabled = sel
        TextIpAddr2Bx.Enabled = sel
        TextIpAddr3Bx.Enabled = sel
        NumericPortNoUpDown.Enabled = sel
        PictureOffBox.Visible = sel
    End Sub

    '//***********************************************************************
    '//  Processing : Open / Close Button
    '//***********************************************************************

    Private Sub CommandDevOpenBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandDevOpenBt.Click
        PDSA_CommButtonEnable(2)                        'ڑ҂
        LabelReciveWork.Text = " Open"
        Me.Refresh()
        Try
            If SocketOpen() = False Then
                LabelReciveWork.Text = " Connect Error"
                PDSA_CommButtonEnable(0)                'ؒf
                Exit Sub
            End If
            Sleep(500)
            LabelReciveWork.Text = ""
            SendDataSet(False, "ADRS 1")                '[JAhXw
            SendDataSet(False, "MONDSP 0")              'ʏ\
            PDSA_CommButtonEnable(1)                    'ڑ
            Me.Refresh()
            Sleep(100)
            Timer1.Enabled = True
            TextSendBx.Text = ""

        Catch ex As System.IO.IOException
            LabelReciveWork.Text = " Connect Error"
            Timer1.Enabled = False
            SocketClose()
            PDSA_CommButtonEnable(0)                    'ؒf
        End Try
    End Sub

    Private Sub CommandDevCloseBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandDevCloseBt.Click
        SendDataSet(False, "GTL")                       '[g
        PDSA_CommButtonEnable(2)                        'ؒf҂
        LabelReciveWork.Text = " Close"
        Me.Refresh()
        Timer1.Enabled = False
        Sleep(500)
        SocketClose()
        TextSendBx.Text = ""
        LabelReciveWork.Text = ""
        PDSA_CommButtonEnable(0)                        'ؒf
    End Sub

    '//***********************************************************************
    '//  Processing : Command Button
    '//***********************************************************************

    Private Sub CommandSaveBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandSaveBt.Click
        IpSaveFileWrite()
    End Sub

    Private Sub CommandOutOnBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandOutOnBt.Click
        SendDataSet(True, "OUTPUT 1")
    End Sub

    Private Sub CommandOutOffBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandOutOffBt.Click
        SendDataSet(True, "OUTPUT 0")
    End Sub

    Private Sub CommandPreset1Bt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandPreset1Bt.Click
        SendDataSet(True, "PRESET 1")
    End Sub

    Private Sub CommandPreset2Bt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandPreset2Bt.Click
        SendDataSet(True, "PRESET 2")
    End Sub

    Private Sub CommandPreset3Bt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandPreset3Bt.Click
        SendDataSet(True, "PRESET 3")
    End Sub

    Private Sub CommandMoniVoltBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandMoniVoltBt.Click
        SendDataSet(True, "VREAD?")
    End Sub

    Private Sub CommandMoniCurrBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandMoniCurrBt.Click
        SendDataSet(True, "AREAD?")
    End Sub

    Private Sub CommandInformationBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandInformationBt.Click
        SendDataSet(True, "*IDN?")
    End Sub

    Private Sub CommandRatedBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandRatedBt.Click
        SendDataSet(True, "MODEL?")
    End Sub

    Private Sub CommandRemOffBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandRemOffBt.Click
        SendDataSet(True, "GTL")
    End Sub

    Private Sub CommandSendBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandSendBt.Click
        SendDataSet(False, TextSendBx.Text)
    End Sub

    Private Sub SendDataSet(ByVal sel As Boolean, ByVal buf As String)
        If sel = True Then
            TextSendBx.Text = buf
        End If
        If 0 < Len(buf) Then
            SocketSendData(buf + Chr(10))
        End If
    End Sub

    Private Sub CommandClearBt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandClearBt.Click
        ListReceiveBx.Items.Clear()
    End Sub

    '//***********************************************************************
    '//  Processing : File
    '//***********************************************************************
    Private Sub IpSaveFileWrite()

        Try
            Dim fp As New IO.StreamWriter(IpSaveFileName)

            fp.WriteLine(TextIpAddr0Bx.Text)
            fp.WriteLine(TextIpAddr1Bx.Text)
            fp.WriteLine(TextIpAddr2Bx.Text)
            fp.WriteLine(TextIpAddr3Bx.Text)
            fp.WriteLine(NumericPortNoUpDown.Value.ToString)
            fp.Close()
            Exit Sub
        Catch
        End Try
    End Sub

    Private Sub IpSaveFileRead()
        Try
            Dim buf As String
            Dim fp As New IO.StreamReader(IpSaveFileName)

            TextIpAddr0Bx.Text = Trim(Str(Val(fp.ReadLine)))
            TextIpAddr1Bx.Text = Trim(Str(Val(fp.ReadLine)))
            TextIpAddr2Bx.Text = Trim(Str(Val(fp.ReadLine)))
            TextIpAddr3Bx.Text = Trim(Str(Val(fp.ReadLine)))
            buf = fp.ReadLine
            fp.Close()
            If buf <> Nothing Then
                NumericPortNoUpDown.Value = Val(buf)
                Exit Sub
            End If
        Catch
        End Try
        TextIpAddr0Bx.Text = 192
        TextIpAddr1Bx.Text = 168
        TextIpAddr2Bx.Text = 1
        TextIpAddr3Bx.Text = 1
        NumericPortNoUpDown.Value = 10001
    End Sub

    '//***********************************************************************
    '//  Processing : IP Address TextBox
    '//***********************************************************************

    Private Sub TextIpAddrBx_KeyPress(ByVal sender As System.Object, ByVal evn As System.Windows.Forms.KeyPressEventArgs) Handles TextIpAddr0Bx.KeyPress, TextIpAddr1Bx.KeyPress, TextIpAddr2Bx.KeyPress, TextIpAddr3Bx.KeyPress
        If Asc("0") <= Asc(evn.KeyChar) And Asc(evn.KeyChar) <= Asc("9") Then
        ElseIf 8 <> Asc(evn.KeyChar) Then
            evn.KeyChar = ""
        End If
    End Sub

    Private Sub TextIpAddrBx_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextIpAddr0Bx.TextChanged, TextIpAddr1Bx.TextChanged, TextIpAddr2Bx.TextChanged, TextIpAddr3Bx.TextChanged
        Dim dat As System.Windows.Forms.TextBox
        Dim ln As Integer

        dat = sender
        If 3 < Len(dat.Text) Then
            ln = dat.SelectionStart
            dat.Text = Mid(dat.Text, 2)
            If 1 < ln Then
                dat.SelectionStart = ln - 1
            End If
        End If

    End Sub

    Private Sub TextIpAddrBx_LostFocus(ByVal sender As Object, ByVal evn As System.EventArgs) Handles TextIpAddr0Bx.LostFocus, TextIpAddr1Bx.LostFocus, TextIpAddr2Bx.LostFocus, TextIpAddr3Bx.LostFocus
        Dim num As Integer
        Dim dat As System.Windows.Forms.TextBox

        dat = sender
        num = Val(dat.Text)
        If 255 < Val(dat.Text) Then
            dat.Text = "255"
        Else
            dat.Text = Trim(num.ToString)
        End If
    End Sub

    '/***********************************************************************/
    ' VB.NET̃\PbgʐMTv
    '   Public Class Form1
    ' \Pbg
    '/***********************************************************************/
    Private Function SocketOpen() As Boolean
        ' \Pbgڑ
        Dim ip As String
        Dim port As Integer

        ip = Trim(TextIpAddr0Bx.Text) + "." + Trim(TextIpAddr1Bx.Text) + "." + Trim(TextIpAddr2Bx.Text) + "." + Trim(TextIpAddr3Bx.Text)
        port = NumericPortNoUpDown.Value
        objSck = Nothing
        Try
            objSck = New System.Net.Sockets.TcpClient
            objSck.Connect(ip, port)
            objStm = objSck.GetStream()
            SocketOpen = True

        Catch
            SocketOpen = False
        End Try
    End Function

    Private Sub SocketClose()
        ' \PbgN[Y
        objStm.Close()
        objSck.Close()
        objSck = Nothing
    End Sub

    Private Sub SocketSendData(ByVal buf As String)
        ' \PbgM
        If 0 < Len(buf) Then
            Dim dat As Byte() = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetBytes(buf)
            objStm.Write(dat, 0, dat.GetLength(0))
        End If
    End Sub

    Private Sub SocketReadData()
        ' \PbgM

        If 0 < objSck.Available Then
            Dim chr As Integer
            Dim ln As Integer
            Dim lmax As Integer
            Dim buf As String
            Dim dat As Byte() = New Byte(objSck.Available - 1) {}

            objStm.Read(dat, 0, dat.GetLength(0))
            buf = System.Text.Encoding.GetEncoding("SHIFT-JIS").GetString(dat)
            lmax = Len(buf)
            For ln = 1 To lmax
                chr = Asc(Mid(buf, ln, 1))
                If chr = 10 Then
                    If 0 < Len(LabelReciveWork.Text) Then
                        If 8 < ListReceiveBx.Items.Count Then
                            ListReceiveBx.Items.RemoveAt(0)
                        End If
                        ListReceiveBx.Items.Add(LabelReciveWork.Text)
                        LabelReciveWork.Text = ""
                    End If
                ElseIf 32 <= chr Then
                    LabelReciveWork.Text = LabelReciveWork.Text + Mid(buf, ln, 1)
                End If
            Next
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        SocketReadData()
    End Sub

End Class
