Option Strict Off
Option Explicit On

Friend Class PDSA_Access
    Inherits System.Windows.Forms.Form
    '/***********************************************************************/
    '/*                                                                     */
    '/*     IF-70@API_Test  for Visual Basic .net 2005                     */
    '/*       Interface   National Instruments USB / RS-232C				*/
    '/*                                                                     */
    '/*       PDSA_Access VBA Sample : Ver 1.1.2                            */                                                    */
    '/*                                                                     */
    '/*     Copyright(c) 2012  TEXIO TECHNOLOGY CORPORATION                 */
    '/***********************************************************************/

    Public DeviceId As Integer    'Device Handle
    Public g_IfSelect As Short    'g_IfSelectect 0:close,1:USB,2:COM1
    Public g_SysAddr As String    'local Addr Name
    Public g_PcAddr As Integer    'PC Addr


    Private Sub PDSA_Access_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim index As Short

        Combo1.Items.Add(("USB"))
        Combo1.Items.Add(("COM"))
        For index = 1 To 30
            Combo2.Items.Add((Str(index)))
            Combo3.Items.Add((Str(index)))
        Next index
        CommandBtEnableSet(0)                           ' Botton Deceble
    End Sub

    Private Sub PDSA_Access_FormClosing(ByVal sender As Object, ByVal EventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim Cancel As Boolean = EventArgs.Cancel
        Dim UnloadMode As System.Windows.Forms.CloseReason = EventArgs.CloseReason 'Form Close(x Button)

        If Combo1.Enabled = False Then
            PDSA_Send(g_PcAddr, C_ADDR & "0")           ' Global Address
            PDSA_Send(g_PcAddr, C_OUT_OFF)
            PDSA_Send(g_PcAddr, C_REMOTE_OFF)
            PDSA_DeviceClose(g_PcAddr)
        End If
        EventArgs.Cancel = Cancel
    End Sub

    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click 'device OPEN/CLOSE

        If Command1.Text = "OPEN" Then 'device OPEN
            Select Case (Combo1.Text)
                Case "USB"
                    g_IfSelect = IF_USB
                Case "COM"
                    g_IfSelect = IF_COM1
            End Select

            g_PcAddr = Val(Combo2.Text)
            g_SysAddr = "ADRS " & Trim(Combo3.Text)
            DeviceId = PDSA_DeviceOpen(g_PcAddr)

            If DeviceId > 0 Then
                PDSA_Send(g_PcAddr, g_SysAddr)
                PDSA_Send(g_PcAddr, C_OUT_OFF)
                PDSA_Send(g_PcAddr, C_DISP1)
                CommandBtEnableSet(1)                   ' Botton Enable
                Text1.Text = ""
            Else
                Text1.Text = " Device Open ERR"
            End If
        Else 'device close
            PDSA_Send(g_PcAddr, C_ADDR & "0")           ' Global Address
            PDSA_Send(g_PcAddr, C_OUT_OFF)
            PDSA_Send(g_PcAddr, C_REMOTE_OFF)
            PDSA_DeviceClose(g_PcAddr)
            CommandBtEnableSet(0)                       ' Botton Deceble
            Text1.Text = ""
            g_IfSelect = 0
        End If
    End Sub

    Private Sub CommandBtEnableSet(ByVal mode As Integer)
        Dim sel As Boolean

        If mode = 1 Then
            sel = True
            Command1.Text = "CLOSE"
        Else
            sel = False
            Command1.Text = "OPEN"
        End If
        Command2.Text = "ON"
        Command2.BackColor = System.Drawing.SystemColors.Control
        Command2.Enabled = sel
        Command3.Enabled = sel
        Command4.Enabled = sel
        Command5.Enabled = sel
        Command6.Enabled = sel
        Command7.Enabled = sel
        If mode = 0 Then
            sel = True
        Else
            sel = False
        End If
        Combo1.Enabled = sel
        Combo2.Enabled = sel
        Combo3.Enabled = sel

    End Sub

    Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click 'OUTPUT On/Off
        If Command2.Text = "ON" Then
            Command2.Text = "OFF"
            PDSA_Send(g_PcAddr, C_OUT_ON)
            Command2.BackColor = System.Drawing.Color.Pink
        Else
            Command2.Text = "ON"
            PDSA_Send(g_PcAddr, C_OUT_OFF)
            Command2.BackColor = System.Drawing.SystemColors.Control
        End If
    End Sub

    Private Sub Command3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command3.Click 'Preset 1 call
        PDSA_Send(g_PcAddr, C_PRESET & "1")
    End Sub

    Private Sub Command4_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command4.Click 'Preset 2 call
        PDSA_Send(g_PcAddr, C_PRESET & "2")
    End Sub

    Private Sub Command5_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command5.Click 'Preset 3 call
        PDSA_Send(g_PcAddr, C_PRESET & "3")
    End Sub

    Private Sub Command6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command6.Click
        PDSA_Send(g_PcAddr, C_REMOTE_OFF)
    End Sub

    Private Sub Command7_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command7.Click 'Request Monitoring Value
        Dim bbuf As String
        Dim buf As String
        Dim meas_value As Object
        Dim vol As Double
        Dim cur As Double
        Dim watt As Double

        bbuf = Space(64)
        PDSA_Send(g_PcAddr, C_READBACK)
        PDSA_Recive(g_PcAddr, 64, bbuf)
        meas_value = Split(bbuf, ",")
        If UBound(meas_value) > 2 Then
            vol = meas_value(2)
            cur = meas_value(3)
            watt = vol * cur
            Text1.Text = Space(8) + "READ DATA" + Chr(13) + Chr(10)
            buf = vol.ToString("0.0##")
            Text1.Text = Text1.Text + Space(17 - Len(buf)) + buf + " [V]" + Chr(13) + Chr(10)
            buf = cur.ToString("0.0##")
            Text1.Text = Text1.Text + Space(17 - Len(buf)) + buf + " [A]" + Chr(13) + Chr(10)
            buf = watt.ToString("0.0##")
            Text1.Text = Text1.Text + Space(17 - Len(buf)) + buf + " [W]" + Chr(13) + Chr(10)
            Text1.Text = Text1.Text + Space(5) + Str(meas_value(1)) & " [0:CV/1:CC/2:OFF]"
        End If
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub Combo1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo1.SelectedIndexChanged
        If Combo1.Text = "COM" Then
            Label4.Text = "COM PORT"
        Else
            Label4.Text = "PC ADDR"
        End If
    End Sub


    '/***********************************************************************/
    '/*     IF-70@Interface Select                                         */
    '/***********************************************************************/

    Private Function PDSA_DeviceOpen(ByRef addr As Integer) As Integer

        Select Case (g_IfSelect)
            Case IF_USB
                PDSA_DeviceOpen = USB488_DeviceOpen(addr)
            Case IF_COM1
                PDSA_DeviceOpen = PDSA_ComOpen(addr)
        End Select
    End Function

    Private Function PDSA_ComOpen(ByRef addr As Integer) As Integer
        Try
            SerialPort1.PortName = "COM" & Trim(Str(g_PcAddr))
            SerialPort1.Open()
            PDSA_ComOpen = 1
        Catch ex As System.IO.IOException
            SerialPort1.Close()
            PDSA_ComOpen = 0
        End Try
    End Function

    Private Function PDSA_DeviceClose(ByRef addr As Integer) As Integer

        Select Case (g_IfSelect)
            Case IF_USB
                PDSA_DeviceClose = USB488_DeviceClose(addr)
            Case IF_COM1
                SerialPort1.Close()
                PDSA_DeviceClose = 0

        End Select
    End Function

    Private Function PDSA_SetRemote(ByRef addr As Integer, ByRef rMode As Integer) As Integer

        Select Case (g_IfSelect)
            Case IF_USB
                PDSA_SetRemote = USB488_SetRemote(addr, rMode)

            Case IF_COM1
                PDSA_SetRemote = 0

        End Select
    End Function

    Private Function PDSA_Send(ByRef addr As Integer, ByRef strBuf As String) As Integer

        Select Case (g_IfSelect)
            Case IF_USB
                PDSA_Send = USB488_Send(addr, strBuf)

            Case IF_COM1
                SerialPort1.DiscardInBuffer()
                SerialPort1.WriteLine(strBuf)
                PDSA_Send = Len(strBuf)
        End Select
    End Function

    Private Function PDSA_Recive(ByRef addr As Integer, ByRef Count As Integer, ByRef strBuf As String) As Integer
        strBuf = Space(Count + 1)
        Select Case (g_IfSelect)
            Case IF_USB
                PDSA_Recive = USB488_Receive(addr, Count, strBuf)
                If PDSA_Recive > 0 Then
                    strBuf = Strings.Left(strBuf, PDSA_Recive)
                End If

            Case IF_COM1
                Sleep(200)
                strBuf = SerialPort1.ReadExisting
                PDSA_Recive = Len(strBuf)
        End Select
    End Function

 

End Class